/********************************************************************************************************
*
* File                : DS2401.c
* Hardware Environment:	DVK501 && F320 EX
* Build Environment   : Silicon LABs 3.42.00 20100913
* Version             : 
* By                  : Su Wei Feng
*
*                                  (c) Copyright 2005-2010, WaveShare
*                                       http://www.waveshare.net
*                                          All Rights Reserved
*
*********************************************************************************************************/

#define _DVK501_F320_EX_

#include <c8051f320.h>
#include <../../../library/ws_clock.h>
#include <../../../library/ws_delay.h>
#include <../../../library/ws_ds2401.h>
#include <../../../library/ws_lcd_st7920_port.h>

void main(void)
{
	uchar serial_number[8];
	uchar n;
	PCA0MD &= ~0x40;            // Clear watchdog timer enable
   	clock_external();			// Set oscillator in external,the clock is 12M
	delay_ms(100);
	XBR1 = 0x40;                // Enable crossbar and weak pull-ups
	getDs2401Number(serial_number);
	SPI_Init();
	st7920LcdInit();
	
	showLine(0,0,lcd_buffer,"DS2401 Example");
	showLine(0,1,lcd_buffer,"Serial Number:");
	refreshLCD(lcd_buffer);
	for(n=0;n<8;n++)
	{
		showLine(n*4,2,lcd_buffer,"%x2H",serial_number[n]);
	}

	refreshLCD(lcd_buffer); 
	while(1);
}